// author - Parag Tambe ... paragtambe@hotmail.com
// changes - added titles - Nov 12, 1999

import java.awt.*;
import java.awt.*;
import java.awt.event.*;
import java.net.*;
import java.applet.*;
import java.io.*;

public class SnapsViewer extends Applet implements Runnable, ActionListener
{
    Thread animate = null;
    private Graphics m_graphics;
    private Image   images[];
    private int currImage;
    private int currImageWidth = 0;
    private int currImageHeight = 0;
    private boolean allLoaded = false;
    private int numOfImages = 18;
    private int delay = 1000;
    private String whoseImages = "my";
    TextField txtNumOfImages;
    TextField txtDelay;
    Label lblNumOfImages;
    Label lblDelay;
    Label lblDelay1;
    Label lblWhoseImages;
    Button bBack2Home;
    CheckboxGroup cbgImages;
    Checkbox cbImages1;
    Checkbox cbImages2;
    Button bImages;
    Button bPause;
    Button bResume;
    File f;
    RandomAccessFile rf;
    DataInputStream di;
    String imgTitles[];
    String errMsg = "";
    boolean errFlag = false;
    boolean loadedTitles = false;
    Font fnt;

    public void init() {
        txtNumOfImages = new TextField("18");
        txtDelay =       new TextField("1000");
        lblNumOfImages = new Label("How many images ? : ");
        lblDelay =       new Label("Delay ");
        lblDelay1 =      new Label(" (msecs) ");
        lblWhoseImages = new Label(" Whose Snaps ? ");
        bBack2Home  = new Button(" Back to home ");
        bImages     = new Button(" Show'em now !! ");
        bPause      = new Button("Pause");
        bResume   = new Button("Resume");
        cbgImages = new CheckboxGroup();
        cbImages1 = new Checkbox("My ", cbgImages, true);
        cbImages2 = new Checkbox("Ash's", cbgImages, false);
        fnt = new Font("Arial", Font.PLAIN, 18);
        add(lblNumOfImages);
        add(txtNumOfImages);
        add(lblDelay);
        add(txtDelay);
        add(lblDelay1);
        add(lblWhoseImages);
        add(cbImages1);
        add(cbImages2);
        add(bImages);
        add(bBack2Home);
        add(bPause);
        add(bResume);
        bImages.addActionListener(this);
        bPause.addActionListener(this);
        bResume.addActionListener(this);
        bBack2Home.addActionListener(this);
        errFlag = false;
    }

    public void paint(Graphics g) {
       g.setFont(fnt);
       paintBgnd();       
       if (errFlag) {
          g.setColor(Color.red);
          g.drawString("Error " + errMsg, 100, 100);
          g.setColor(Color.black);
       }
       else if (!allLoaded) {
          g.setColor(Color.white);
          g.drawString("Loading " + whoseImages + " snaps....Hang on for a few seconds..Please...", 100, 100);
          g.setColor(Color.black);
       }
    }

    public void actionPerformed(ActionEvent evt) {
        if (bImages == evt.getSource()) {
            numOfImages = Integer.parseInt(txtNumOfImages.getText().trim());
            delay = Integer.parseInt(txtDelay.getText().trim());
            if (cbImages1.getState())      whoseImages = "my";
            else if (cbImages2.getState()) whoseImages = "Aishwarya's";
            stop();
            allLoaded = false;
            errFlag = false;            
            repaint();
            loadTitles();
            start();
        }
        else if (bBack2Home == evt.getSource()) {
            stop();
            try {
                URL u = new URL("http://www.geocities.com/SiliconValley/Garage/2821");
                AppletContext appletCtxt = getAppletContext();
                appletCtxt.showDocument(u);
            }
            catch (MalformedURLException mfx) {
                errFlag = true;
                errMsg = "MalformedURLException in going back 2 home";
                repaint();
            }
        }
        else if (bPause == evt.getSource())  pause();
        else if (bResume == evt.getSource()) resume();
    }

    public void pause() {
       if (animate != null)  animate.suspend();
    }

    public void resume() {
       if (animate != null)  animate.resume();
    }

    public void start() {
       if (animate == null)  {
           animate = new Thread(this);
           animate.start();
       }
    }

    public void stop() {
       if (animate != null)  {
           animate.stop();
           animate = null;
       }
    }

    public void run() {
       currImage = 0;
       boolean isError = false;
       if (!allLoaded) {
          m_graphics = getGraphics();
          images = new Image[numOfImages];
          MediaTracker tracker = new MediaTracker(this);
          String sImg = "";
          String sImgPrfx = "";
          if (whoseImages.equals("Aishwarya's")) sImgPrfx = "img";
          else sImgPrfx = "imgp";
          for (int i = 1; i<=numOfImages; i++) {
              sImg = sImgPrfx + String.valueOf(i).trim()  + ".jpg";
              images[i-1] = getImage(getDocumentBase(), sImg);
              tracker.addImage(images[i-1], 0);
          }
          try {
            tracker.waitForID(0);
            isError = tracker.isErrorAny();
          }
          catch (Exception ex) {
              errFlag = true;
              errMsg = "Loading images";
              repaint();
              stop();
          }
          finally {
             if (!isError) allLoaded = true;
             else {
                errFlag = true;
                errMsg = "Loading images";
                repaint();
                stop();
             }
          }
          //currImageWidth  = images[0].getWidth(this);
          //currImageHeight = images[0].getHeight(this);
       }
       //repaint();
       if (allLoaded) {
           // load titles if not already loaded
           if (!loadedTitles) loadTitles();
           while (true) {
              try {
                  paintBgnd();
                  displayImage(m_graphics);
                  currImage++;
                  if (currImage == numOfImages) currImage = 0;
                  Thread.sleep(delay);
              }
              catch (InterruptedException ex) {
                  stop();
              }
           }
       }
    }

    private void loadTitles() {
       // first load all the titles
       try {
           String sTitleFileName = "MySnaps.txt";
           if (whoseImages.equals("Aishwarya's")) sTitleFileName = "Aishwarya.txt";
           // test
           String sUrl = getDocumentBase().toString();
           sUrl = sUrl.substring(0, sUrl.lastIndexOf("/")+1);
           URL uu = new URL(sUrl + sTitleFileName);
           di = new DataInputStream(uu.openStream());
           imgTitles = new String[numOfImages];
           for (int i = 0; i<numOfImages; i++) imgTitles[i] = di.readLine();
       }
       catch (MalformedURLException mfx) {
           errFlag = true;
           errMsg = "MalformedURLException in loading titles";
           repaint();
           stop();
       }
       catch (IOException iox) {
           errFlag = true;
           errMsg = "IOException in loading titles";
           repaint();
           stop();
       }
       finally {
          try {
            if (di != null) di.close();
            else loadedTitles = true;
          }
          catch (IOException iox) {}
       }
    }

    private void paintBgnd() {
      Graphics g = getGraphics();
      g.setColor(Color.black);
      g.fillRect(0, 0, size().width, size().height);
    }

    private void displayImage(Graphics g) {
        if (!allLoaded) return;
        g.setColor(Color.white);
        g.setFont(fnt);
        g.drawString(imgTitles[currImage], 70, 60);
        g.setColor(Color.black);
        g.drawImage(images[currImage], 70, 70, null);
    }

    //private void clearImage(Graphics g) {
    //g.clearRect(50, 50, currImageWidth, currImageHeight);
    //}
}
